#ifndef _UMLCLASS_H
#define _UMLCLASS_H


#include "UmlBaseClass.h"
#include <qcstring.h>
#include "Vector.h"
#include <qvaluelist.h>

class UmlActualParameter;
class UmlFormalParameter;

// This class manages 'classes', notes that the class 'ClassItem'
// is a mother class of the class's children.
//
// You can modify it as you want (except the constructor)
class UmlClass : public UmlBaseClass {
  public:
    UmlClass(void * id, const QCString & n) : UmlBaseClass(id, n) { inherited_opers = 0; };

    virtual QCString sKind();

    virtual void memo_ref();

    virtual void html(QCString, unsigned int);

    void html();

    virtual void write();

    virtual void write(QCString target);

    static void ref_index();

    static void generate_index();


  private:
    void add_inherited_opers(Vector * ops);


  protected:
    Vector * inherited_opers;

    static Vector classes;


  private:
    void gen_cpp_decl(QCString s, bool descr);

    void gen_java_decl(QCString s);

    void generate(const QValueList<UmlActualParameter> a, UmlClass * mother);

    void generate(const QValueList<UmlFormalParameter> f);


  public:
    static void generate();


  protected:
    Vector subClasses;

};

#endif
