
#include "UmlPackage.h"

#include "UmlClassDiagram.h"

QCString UmlPackage::sKind() {
  return "package";
}

void UmlPackage::html(QCString pfix, unsigned int rank) {
  define();
  
  chapter("Package", pfix, rank, "ffe4c4");

  QCString s = cppNamespace();
  bool ul = FALSE;
  
  if (!s.isEmpty()) {
    fw.write("<p><br><p><ul>\n");
    ul = TRUE;
    fw.write("<li>C++ namespace : ");
    writeq(s);
    fw.write("</li>\n");
  }

  s = javaPackage();
  
  if (!s.isEmpty()) {
    if (! ul)
      fw.write("<p><br><p><ul>");
    ul = TRUE;
    fw.write("<li>Java package : ");
    writeq(s);
    fw.write("</li>\n");
  }
    
  if (ul)
    fw.write("</ul>\n");
    
  s = description();
  
  if (!s.isEmpty()) {
    fw.write("<p>");
    writeq(s);
    fw.write("<br></p>");
  }
  
  const QVector<UmlItem> ch = children();
  unsigned n = ch.size();
  
  if (n != 0) {
    QCString spfix;
    
    if (rank != 0) {
      spfix.setNum(rank);
      spfix = pfix + spfix + ".";
    }
    
    for (unsigned i = 0; i != n; i += 1)
      ch[i]->html(spfix, i + 1);
  }

  UmlDiagram * d = associatedDiagram();
  
  if (d != 0) {
    fw.write("<p>Diagram : ");
    d->write();
    fw.write("</p>\n");
  }

  unload(FALSE, FALSE);
}

