
#include "FileOut.h"
#include "UmlItem.h"

#include <qtextstream.h>
#include <qfile.h>
FileOut::FileOut(QFile * fp) : QTextStream(fp), _indent(0){
}

void FileOut::indent() {
  QTextStream & ts = *this;
  
  for (int n = _indent; n > 0; n -= 1)
    ts << '\t';
}

void FileOut::id(const UmlItem * x) {
  ((QTextStream &) *this) << " xmi.id=\"BOUML_" << ((void *) x) << '"';

}

void FileOut::idref(const UmlItem * x) {
  ((QTextStream &) *this) << " xmi.idref=\"BOUML_" << ((void *) x) << '"';

}

void FileOut::ref(const UmlItem * x) {
  ((QTextStream &) *this) << "BOUML_" << ((void *) x); 
}

void FileOut::idref_datatype(const QCString & t) {
  QMap<QCString, int>::ConstIterator it = _datatypes.find(t);
  
  if (it == _datatypes.end())
    it = _datatypes.insert(t, _datatypes.count());
    
  ((QTextStream &) *this) << " xmi.idref=\"BOUML_datatype_"
    << it.data() << '"';
}

void FileOut::define_datatypes() {
  QMap<QCString, int>::ConstIterator it;
  
  for (it = _datatypes.begin();
       it != _datatypes.end();
       ++it) {
    indent();
    (*this) << "<UML:DataType xmi.id=\"BOUML_datatype_"
            << it.data() << "\" name = \"" << it.key()
	    << "\" visibility=\"private\" isRoot=\"false\" isLeaf=\"false\" isAbstract=\"false\"/>\n";
  }
}

