
#include "UmlAttribute.h"
#include "FileOut.h"

#include "UmlClass.h"
bool UmlAttribute::write_if_needed(FileOut & out) {
  parent()->write(out);
  
  out.indent();
  out << "<UML:Attribute name=\"" << name() << '"';
  out.id(this);
  write_visibility(out);
  write_scope(out);
  out << ">\n";
  
  out.indent(+1);

  const UmlTypeSpec & t = type();
  
  if (t.type != 0) {
    out.indent();
    out << "<UML:StructuralFeature.type>\n";
    out.indent();
    out << "\t<UML:DataType";
    out.idref(t.type);
    out << "/>\n";
    out.indent();
    out << "</UML:StructuralFeature.type>\n";
  }
  else if (!t.explicit_type.isEmpty()) {
    out.indent();
    out << "<UML:StructuralFeature.type>\n";
    out.indent();
    out << "\t<UML:DataType ";
    out.idref_datatype(t.explicit_type);
    out << "/>\n";
    out.indent();
    out << "</UML:StructuralFeature.type>\n";
  }

  write_stereotype(out);
  write_description(out);

  out.indent(-1);
  out.indent();
  out << "</UML:Attribute>\n";

  unload();
 
  return TRUE;
}

