// *************************************************************************
//
// Copyright (C) 2004,2005 Bruno PAGES  All rights reserved.
//
// This file is part of the BOUML Uml Toolkit.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
// e-mail : bouml@free.fr
// home   : http://bouml.free.fr
//
// *************************************************************************

#ifndef TRANSITIONDIALOG_H
#define TRANSITIONDIALOG_H

#include <qwidgetlist.h>
#include <qstringlist.h>

#include "MyTabDialog.h"
#include "BrowserNode.h"

class QPushButton;
class QComboBox;

class LineEdit;
class MultiLineEdit;
class TransitionData;
class BrowserNode;
class KeyValuesTable;
struct TransDef;
class BodyDialog;

struct TransDialog {
  MultiLineEdit * edtrigger;
  MultiLineEdit * edguard;
  MultiLineEdit * edexpr;
  
  void accept(TransDef &);
};

class TransitionDialog : public MyTabDialog {
  Q_OBJECT
    
  protected:
    bool visit;
    TransitionData * rel;
    LineEdit * edname;
    QComboBox * edstereotype;
    MultiLineEdit * comment;
    QList<BodyDialog> edits;
    
    TransDialog uml;
    TransDialog cpp;
    TransDialog java;
        
    // User
    KeyValuesTable * kvtable;
    
    static QSize previous_size;
  
    static void post_edit_description(TransitionDialog * d, QString s);
  
  public:
    TransitionDialog(TransitionData * r, const QPoint & p);
    virtual ~TransitionDialog();
  
  protected:
    void init_tab(TransDialog &, TransDef & td, const char * lbl);
  protected slots:
    virtual void accept();
  
    void edit_description();
};

#endif
