// *************************************************************************
//
// Copyright (C) 2004,2005 Bruno PAGES  All rights reserved.
//
// This file is part of the BOUML Uml Toolkit.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
// e-mail : bouml@free.fr
// home   : http://bouml.free.fr
//
// *************************************************************************

#include <qapplication.h>

#include "UmlGlobal.h"

QFont NormalFont;
QFont BoldFont;
QFont ItalicFont;
QFont BoldItalicFont;
QFont UnderlineFont;
QFont BoldUnderlineFont;
QFont StrikeOutFont;

QColor UmlWhiteColor(0xff, 0xff, 0xff);
QColor UmlYellowColor(0xff, 0xff, 0xc0);
QColor UmlDarkYellowColor(0xff, 0xd7, 0x0);
QColor UmlBlueColor(0xc0, 0xff, 0xff);
QColor UmlDarkBlueColor(0x0, 0x55, 0xff);
QColor UmlGreenColor(0xc0, 0xff, 0xc0);
QColor UmlDarkGreenColor(0x0, 0xaa, 0x0);
QColor UmlRedColor(0xff, 0x00, 0x00);
QColor UmlGrayColor(0xdc, 0xdc, 0xdc);
QColor UmlBlackColor(0, 0, 0);

void init_font()
{
  NormalFont = QApplication::font();
  NormalFont.setFamily("Helvetica");

  BoldFont = NormalFont;
  BoldFont.setBold(TRUE);
  
  ItalicFont = NormalFont;
  ItalicFont.setItalic(TRUE);
  
  BoldItalicFont = ItalicFont;
  BoldItalicFont.setBold(TRUE);
  
  UnderlineFont = NormalFont;
  UnderlineFont.setUnderline(TRUE);
  
  BoldUnderlineFont = BoldFont;
  BoldUnderlineFont.setUnderline(TRUE);
  
  StrikeOutFont = NormalFont;
  StrikeOutFont.setStrikeOut(TRUE);
}

void resize_font(int i)
{
  NormalFont.setPointSize(i);
  BoldFont.setPointSize(i);
  ItalicFont.setPointSize(i);
  BoldItalicFont.setPointSize(i);
  UnderlineFont.setPointSize(i);
  BoldUnderlineFont.setPointSize(i);
  StrikeOutFont.setPointSize(i);
}

const QColor & color(UmlColor c)
{
  // use a switch to not be linked with the color order
  
  switch (c) {
  case UmlWhite:
    return UmlWhiteColor;
  case UmlYellow:
    return UmlYellowColor;
  case UmlDarkYellow:
    return UmlDarkYellowColor;
  case UmlBlue:
    return UmlBlueColor;
  case UmlDarkBlue:
    return UmlDarkBlueColor;
  case UmlGreen:
    return UmlGreenColor;
  case UmlDarkGreen:
    return UmlDarkGreenColor;
  case UmlRed:
    return UmlRedColor;
  case UmlGray:
    return UmlGrayColor;
  default:	// error
    return UmlBlackColor;
  }
}

